require 'spec_helper'

describe BranchableCDNAssets::Config::EnvironmentAttributeReader do

  before :each do
    @subject_class = Class.new do
      attr_reader :environments, :env

      def initialize environments={}, env=:default
        @environments = environments
        @env = env
      end
    end

    @subject_class.send :include, BranchableCDNAssets::Config::EnvironmentAttributeReader
    @subject_class.send :extend,  BranchableCDNAssets::Config::EnvironmentAttributeReader::ClassMethods
  end

  it "raises key missing when trying to access missing key" do
    @subject_class.send :env_attr_reader, :foo

    expect{
      @subject_class.new.foo
    }.to raise_error ArgumentError
  end

  it "returns value of key for environment" do
    @subject_class.send :env_attr_reader, :is_true
    @subject_class.send :env_attr_reader, :is_false

    subject = @subject_class.new default: { is_true: true, is_false: false }
    expect( subject.is_true ).to eq true
    expect( subject.is_false ).to eq false
  end

end